

#include  "System_init.h"


/********************************************************************
 * ƣvoid  Print_Sys()
 * ӡϵͳ
 * none
 * 汾V1.0
********************************************************************/
void  Print_Sys()
{
    u8 i;
    i = SystemCoreClock / 1000000;

    printf("\r\n");
    if( EEPROM_buff[1] == Lock_OFF )
    {
        printf("\r\n        豸ϵӦ!  \r\n");       //ӡ
        Lock_flag = 1;
    }
    else
        Lock_flag = 0;
    printf("\r\n");
    printf("->10··̵\r\n");
    printf("->ӲãCH32V203RBT6\r\n");
    printf("->ϵͳʱ: %d MHZ\r\n", (u16)i);
    printf("->̫汾: %x\r\n",WCHNET_GetVer());
//    printf("->MCUк: %x\r\n",MCU_ID);

    printf("->MCUк: ");
    for(i = 0; i < 12; i++)
    {
        printf("%x ",MCU_ID[i]);
        if( i<= 10 )
            printf(":");
    }

 /*
    printf("->MACַ: ");
    for(i = 0; i < 6; i++)
    {
        printf("%x ",MACAddr[i]);
        if( i<= 4 )
            printf(":");
    }
*/
    printf("\r\n->ģIP: ");
    for(i = 0; i < 4; i++)
    {
        printf("%d ",IPAddr[i]);
        if( i<= 2 )
           printf(".");
    }                           //ģIPַ

    printf("\r\n->IP: ");
    for(i = 0; i < 4; i++)
    {
        printf("%d ",DESIP[i]);
        if( i<= 2 )
           printf(".");
    }                           //ĿIPַ
    printf("\r\n->˿:%d \r\n",DESIP_port);       //˿
}

/********************************************************************
 * ƣvoid IWDG_Feed_Init(u16 prer, u16 rlr)
 * Źʼ
 * none
 * 汾V1.0
********************************************************************/
void IWDG_Feed_Init(u16 prer, u16 rlr)
{
    IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
    IWDG_SetPrescaler(prer);
    IWDG_SetReload(rlr);
    IWDG_ReloadCounter();
    IWDG_Enable();
}

/********************************************************************
 * ƣvoid GPIOInit(void)
 * ˿ڳʼ
 * none
 * 汾V1.0
********************************************************************/
void GPIOInit(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};                 //ṹ岢ֵ

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOC, ENABLE);

/*   PB6 -> ETHָĬֵ */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

/*   PB12 -> LED״ָ̬ʾ */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

/*   1-10·̵ */
     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
     GPIO_Init(GPIOA, &GPIO_InitStructure);

     GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
     GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
     GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
     GPIO_Init(GPIOC, &GPIO_InitStructure);

     ALL_relay_OFF();

    GPIO_SetBits(GPIOB, GPIO_Pin_12);                     //رָʾ
}

/********************************************************************
 * ƣvoid TIM2_Init(void
 * ʱ2ʼ
 * none
 * 汾V1.0
********************************************************************/
void TIM2_Init(void)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
    TIM_TimeBaseStructure.TIM_Period = SystemCoreClock / 1000000 - 1;
    TIM_TimeBaseStructure.TIM_Prescaler = WCHNETTIMERPERIOD * 1000 - 1;
    TIM_TimeBaseStructure.TIM_ClockDivision = 0;
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
    TIM_ITConfig(TIM2, TIM_IT_Update ,ENABLE);

    TIM_Cmd(TIM2, ENABLE);
    TIM_ClearITPendingBit(TIM2, TIM_IT_Update );
    NVIC_EnableIRQ(TIM2_IRQn);
}

/********************************************************************
 * ƣvoid TIM3_Init(void
 * ʱ2ʼ
 * 100ms
 * 汾V1.0
********************************************************************/
void TIM3_Init(void)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};                     //ṹʼ

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);                    //ʹʱ

    TIM_TimeBaseStructure.TIM_Period = 1000- 1;                             //ʱֵ
    TIM_TimeBaseStructure.TIM_Prescaler = 12000 - 1;                       //Ƶϵ

    TIM_TimeBaseStructure.TIM_ClockDivision = 0;
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);
    TIM_ITConfig(TIM3, TIM_IT_Update ,ENABLE);                              //öʱ3

    TIM_Cmd(TIM3, ENABLE);
    TIM_ClearITPendingBit(TIM3, TIM_IT_Update );
    NVIC_EnableIRQ(TIM3_IRQn);                                              //ж
}

/********************************************************************
 * ƣvoid Rest_ETH()
 * ָĬֵ
 * none
 * 汾V1.0
********************************************************************/
void Rest_ETH()
{
    if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_6) == 0)                       //жPB6==0
    {
        Delay_Ms(100);                                                      //ʱ
        if(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_6) == 0)                   //ٴжPB6==0
        {
            while(GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_6) == 0);           //ȴ
            CFG_ERASE(PAGE_WRITE_START_ADDR,FLASH_PAGE_SIZE);
            CFG_WRITE( PAGE_WRITE_START_ADDR,Default_cfg,MODULE_CFG_LEN );
            NVIC_SystemReset();                                             //λ
        }
    }
}

/********************************************************************
 * ƣvoid Get_ETH()
 *  ȡEEPROMֵ
 * none
 * 汾V1.0
********************************************************************/
void Get_ETH()
{
    u8 i;

    CFG_READ( PAGE_WRITE_START_ADDR,Configbuf,MODULE_CFG_LEN );                 //ȡEEPROMбϢ
    if((CFG->cfg_flag[0]!=checkcode1)||(CFG->cfg_flag[1]!=checkcode2))          //жϲǷЧ
    {
        CFG_ERASE(PAGE_WRITE_START_ADDR,FLASH_PAGE_SIZE);
        CFG_WRITE(PAGE_WRITE_START_ADDR,Default_cfg,MODULE_CFG_LEN );
        NVIC_SystemReset();
    }

    CFG_READ( EEPROM_ADDR, EEPROM_buff, 2 );                 //ȡEEPROMбϢ,Ϣ
    if( EEPROM_buff[0] != 0xF0 )                             //жǷЧ
    {
        CFG_ERASE(EEPROM_ADDR,FLASH_PAGE_SIZE);
        EEPROM_buff[0] = 0xF0;
        EEPROM_buff[1] = Lock_ON;
        CFG_WRITE(EEPROM_ADDR, EEPROM_buff, 2);              //洢
    }

    WCHNET_GetMacAddr(MACAddr);                             //ȡMACַ
    for( i = 0; i < 4; i++ )
    {
        DESIP[i] =  CFG->dest_ip[i];
        IPAddr[i] =  CFG->src_ip[i];
    }
    DESIP_port = (CFG->dest_port[1]*256 + CFG->dest_port[0]);
}


/********************************************************************
 * ƣvoid Get_MCU_number(
 *  ȡMCUк
 * none
 * 汾V1.0
********************************************************************/
void Get_MCU_number()
{
    u32 X,Y,Z;
    u8 i=0;

    X = R32_ESIG_UNIID1 ;            //ȡID
    Y = R32_ESIG_UNIID2 ;            //ȡID
    Z = R32_ESIG_UNIID3 ;            //ȡID

     MCU_ID[i++] = X >> 24;
     MCU_ID[i++] = X >> 16;
     MCU_ID[i++] = X >> 8;
     MCU_ID[i++] = X ;
     MCU_ID[i++] = Y >> 24;
     MCU_ID[i++] = Y >> 16;
     MCU_ID[i++] = Y >> 8;
     MCU_ID[i++] = Y ;
     MCU_ID[i++] = Z >> 24;
     MCU_ID[i++] = Z >> 16;
     MCU_ID[i++] = Z >> 8;
     MCU_ID[i++] = Z ;
}

/********************************************************************
 * ƣvoid MCU_init(void)
 *  MCUʼ
 * none
 * 汾V1.0
********************************************************************/
void MCU_init(void)
{
    Delay_Init();                                               //ʱʼ
    USART_Printf_Init(115200);                                  //õԴڲ
    GPIOInit();                                                 //˿
    TIM2_Init();                                                //ʱ2
    TIM3_Init();                                                //ʱ3
    if( WCHNET_LIB_VER != WCHNET_GetVer() )
    {
        printf("->̫汾,̼");
        while(1);                                               //ѭ
    }
    Rest_ETH();                                                 //ָĬֵ
    Get_ETH();                                                  //ȡ洢
    Get_MCU_number();
    Print_Sys();
    IWDG_Feed_Init(IWDG_Prescaler_32, 1250);
    user_eth_init();
}




